import { pgTable, integer, varchar, text, decimal, uuid, real, bigserial, date, timestamp, boolean, unique, check } from "drizzle-orm/pg-core";
import { sql } from "drizzle-orm";
import { timestamps } from "./helpers/columns.helpers";

export const users = pgTable("users", {
    id: bigserial({ mode: "bigint" }).primaryKey().notNull(),
    username: varchar({ length: 50 }).notNull(),
    email: varchar({ length: 255 }).notNull(),
    passwordHash: varchar("password_hash", { length: 255 }).notNull(),
    firstName: varchar("first_name", { length: 50 }),
    lastName: varchar("last_name", { length: 50 }),
    profilePicture: varchar("profile_picture", { length: 255 }),
    dateOfBirth: date("date_of_birth"),
    phoneNumber: varchar("phone_number", { length: 20 }),
    createdAt: timestamp("created_at", { mode: 'string' }).default(sql`CURRENT_TIMESTAMP`),
    updatedAt: timestamp("updated_at", { mode: 'string' }).default(sql`CURRENT_TIMESTAMP`),
    isAdmin: boolean("is_admin").default(false),
    lastLogin: timestamp("last_login", { mode: 'string' }),
    emailVerified: boolean("email_verified").default(false),
    buildPrivacySetting: text("build_privacy_setting").default('public'),
}, (table) => {
    return {
        usersUsernameKey: unique("users_username_key").on(table.username),
        usersEmailKey: unique("users_email_key").on(table.email),
        usersBuildPrivacySettingCheck: check("users_build_privacy_setting_check", sql`build_privacy_setting = ANY (ARRAY['private'::text, 'public'::text])`),
    }
});